﻿@page "/productsPage"
@using SPAWebApp.Shared.Models
@using SPAWebApp.Client.Services.Contracts
@using SPAWebApp.Shared.Models.Services.Product
@inject IProductCardService ProductService

<div class="container-fluid d-flex h-100 flex-column">
  <!-- Products Section -->
  <div class="row justify-content-center d-flex flex-fill">
    <div class="col-12">
      <div class="content-files container-fluid d-flex flex-column h-100">
        @if (SelectedProduct == null)
        {
          <!-- Controls -->
          <div class="top-menu">
            <button class="btn btn-info" title="Добавить"><i class="fas fa-plus"></i></button>
            <button class="btn btn-info" title="Экспорт"><i class="fas fa-file-excel"></i></button>
          </div>
          <!-- End Controls -->
          <!-- Search -->
          <div class="block-search">
            <input type="search" name="search">
            <button type="button" class="btn btn-primary btn-sm btn-search"><i class="fas fa-search"></i></button>
          </div>
          <!-- End Search -->
          <!-- Products List -->
          <div id="table">
            <ProductList Products="@Products"
                         SelectedProducts="@SelectProduct" />
          </div>
          <!-- End Products List -->
        <div>
        <button onclick="@(async () => await PreviousPage())">Prev</button>
        <button>@CurrentPage</button>
        <button onclick="@(async () => await NextPage())">Next</button>
        </div>
        }
        else
        {
          <div class="row">
            <button class="btn btn-info" title="Назад"><i class="fas fa-arrow-circle-left" onclick="@(() => ChangeBool())"></i> </button>
          </div>
          <div class="row d-flex flex-fill">
            <ProductInfo Product="@SelectedProduct" />
          </div>
        }
      </div>
    </div>
  </div>
  <!-- End Products Section -->
</div>


@functions {
  protected List<Product> Products;
  protected Product SelectedProduct;

  protected Boolean state;

  public int PagesCount { get; set; } = 0;

  public int CurrentPage { get; set; } = 0;

  protected override async Task OnInitAsync()
  {
    Console.WriteLine($"{nameof(ProductPage)}.{nameof(OnInitAsync)}");

    var result = await ProductService.GetProductsOfFirstPageAsync();
    Products = result.Products;
    CurrentPage = 0;
    PagesCount = result.Pages;

    StateHasChanged();

    Console.WriteLine($"{nameof(ProductPage)}.{nameof(OnInitAsync)}: done");

    //Products = 
  }

  protected async Task NextPage()
  {
    Products = await ProductService.GetProductsOfPageAsync(CurrentPage++);
  }

  protected async Task PreviousPage()
  {
    Products = await ProductService.GetProductsOfPageAsync(CurrentPage--);
  }

  protected void SelectProduct(Product product)
  {
    SelectedProduct = new Product()
    {
      Id = product.Id,
      Designation = product.Designation,
      Version = product.Version,
      State = product.State,
      ModelId = product.ModelId,
      ModelIdView = product.ModelIdView,
      Weight = product.Weight,
      Name = product.Name
    };
    this.StateHasChanged();
  }
  protected void ChangeBool()
  {
    SelectedProduct = null;
  }
}